From 984de1a707e87d53530b809862a2e018d6a311e7 Mon Sep 17 00:00:00 2001
From: Neal Gompa <ngompa13@gmail.com>
Date: Mon, 30 May 2016 16:28:43 -0400
Subject: [PATCH 3/4] Add Mageia 6 build targets

---
 etc/mock/mageia-6-armv5tl.cfg | 67 +++++++++++++++++++++++++++++++++++++++++
 etc/mock/mageia-6-i586.cfg    | 67 +++++++++++++++++++++++++++++++++++++++++
 etc/mock/mageia-6-x86_64.cfg  | 69 +++++++++++++++++++++++++++++++++++++++++++
 3 files changed, 203 insertions(+)
 create mode 100644 etc/mock/mageia-6-armv5tl.cfg
 create mode 100644 etc/mock/mageia-6-i586.cfg
 create mode 100644 etc/mock/mageia-6-x86_64.cfg

diff --git a/etc/mock/mageia-6-armv5tl.cfg b/etc/mock/mageia-6-armv5tl.cfg
new file mode 100644
index 0000000..e31e91b
--- /dev/null
+++ b/etc/mock/mageia-6-armv5tl.cfg
@@ -0,0 +1,67 @@
+config_opts['root'] = 'mageia-6-armv5tl'
+config_opts['target_arch'] = 'armv5tl'
+config_opts['legal_host_arches'] = ('armv5tl', 'armv6l', 'armv7l', 'armv7hl')
+config_opts['chroot_setup_cmd'] = 'install basesystem-minimal rpm-build rpm-mageia-setup rpm-mageia-setup-build'
+config_opts['dist'] = 'mga6'  # only useful for --resultdir variable subst
+config_opts['extra_chroot_dirs'] = [ '/run/lock', ]
+config_opts['useradd'] = '/usr/sbin/useradd -o -m -u %(uid)s -g %(gid)s -d %(home)s %(user)s'
+config_opts['releasever'] = '6'
+config_opts['package_manager'] = 'dnf'
+
+config_opts['yum.conf'] = """
+[main]
+keepcache=1
+debuglevel=2
+reposdir=/dev/null
+logfile=/var/log/yum.log
+retries=20
+obsoletes=1
+gpgcheck=0
+assumeyes=1
+syslog_ident=mock
+syslog_device=
+install_weak_deps=0
+metadata_expire=0
+
+
+[mageia]
+name=Mageia $releasever - armv5tl
+#baseurl=http://mirrors.kernel.org/mageia/distrib/$releasever/armv5tl/media/core/release/
+#metalink=https://mirrors.mageia.org/metalink?distrib=mageia-$releasever&arch=armv5tl@&section=core&repo=release
+mirrorlist=https://www.mageia.org/mirrorlist/?release=$releasever&arch=armv5tl&section=core&repo=release
+gpgcheck=1
+gpgkey=file:///etc/pki/mock/RPM-GPG-KEY-Mageia
+failovermethod=priority
+enabled=1
+
+[updates]
+name=Mageia $releasever - armv5tl - Updates
+#baseurl=http://mirrors.kernel.org/mageia/distrib/$releasever/armv5tl/media/core/updates/
+#metalink=https://mirrors.mageia.org/metalink?distrib=mageia-$releasever&arch=armv5tl@&section=core&repo=updates
+mirrorlist=https://www.mageia.org/mirrorlist/?release=$releasever&arch=armv5tl&section=core&repo=updates
+gpgcheck=1
+gpgkey=file:///etc/pki/mock/RPM-GPG-KEY-Mageia
+failovermethod=priority
+enabled=1
+
+[mageia-debuginfo]
+name=Mageia $releasever - armv5tl - Debug
+#baseurl=http://mirrors.kernel.org/mageia/distrib/$releasever/armv5tl/media/debug/core/release/
+#metalink=https://mirrors.mageia.org/metalink?distrib=mageia-$releasever&arch=armv5tl@&section=core&repo=release&debug=true
+mirrorlist=https://www.mageia.org/mirrorlist/?release=$releasever&arch=armv5tl&section=core&repo=release&debug=1
+gpgcheck=1
+gpgkey=file:///etc/pki/mock/RPM-GPG-KEY-Mageia
+failovermethod=priority
+enabled=0
+
+[updates-debuginfo]
+name=Mageia $releasever - armv5tl - Updates - Debug
+#baseurl=http://mirrors.kernel.org/mageia/distrib/$releasever/armv5tl/media/debug/core/updates/
+#metalink=https://mirrors.mageia.org/metalink?distrib=mageia-$releasever&arch=armv5tl@&section=core&repo=updates&debug=true
+mirrorlist=https://www.mageia.org/mirrorlist/?release=$releasever&arch=armv5tl&section=core&repo=updates&debug=1
+gpgcheck=1
+gpgkey=file:///etc/pki/mock/RPM-GPG-KEY-Mageia
+failovermethod=priority
+enabled=0
+
+"""
diff --git a/etc/mock/mageia-6-i586.cfg b/etc/mock/mageia-6-i586.cfg
new file mode 100644
index 0000000..c377b88
--- /dev/null
+++ b/etc/mock/mageia-6-i586.cfg
@@ -0,0 +1,67 @@
+config_opts['root'] = 'mageia-6-i586'
+config_opts['target_arch'] = 'i586'
+config_opts['legal_host_arches'] = ('i386', 'i586', 'i686', 'x86_64')
+config_opts['chroot_setup_cmd'] = 'install basesystem-minimal rpm-build rpm-mageia-setup rpm-mageia-setup-build'
+config_opts['dist'] = 'mga6'  # only useful for --resultdir variable subst
+config_opts['extra_chroot_dirs'] = [ '/run/lock', ]
+config_opts['useradd'] = '/usr/sbin/useradd -o -m -u %(uid)s -g %(gid)s -d %(home)s %(user)s'
+config_opts['releasever'] = '6'
+config_opts['package_manager'] = 'dnf'
+
+config_opts['yum.conf'] = """
+[main]
+keepcache=1
+debuglevel=2
+reposdir=/dev/null
+logfile=/var/log/yum.log
+retries=20
+obsoletes=1
+gpgcheck=0
+assumeyes=1
+syslog_ident=mock
+syslog_device=
+install_weak_deps=0
+metadata_expire=0
+
+
+[mageia]
+name=Mageia $releasever - i586
+#baseurl=http://mirrors.kernel.org/mageia/distrib/$releasever/i586/media/core/release/
+#metalink=https://mirrors.mageia.org/metalink?distrib=mageia-$releasever&arch=i586@&section=core&repo=release
+mirrorlist=https://www.mageia.org/mirrorlist/?release=$releasever&arch=i586&section=core&repo=release
+gpgcheck=1
+gpgkey=file:///etc/pki/mock/RPM-GPG-KEY-Mageia
+failovermethod=priority
+enabled=1
+
+[updates]
+name=Mageia $releasever - i586 - Updates
+#baseurl=http://mirrors.kernel.org/mageia/distrib/$releasever/i586/media/core/updates/
+#metalink=https://mirrors.mageia.org/metalink?distrib=mageia-$releasever&arch=i586@&section=core&repo=updates
+mirrorlist=https://www.mageia.org/mirrorlist/?release=$releasever&arch=i586&section=core&repo=updates
+gpgcheck=1
+gpgkey=file:///etc/pki/mock/RPM-GPG-KEY-Mageia
+failovermethod=priority
+enabled=1
+
+[mageia-debuginfo]
+name=Mageia $releasever - i586 - Debug
+#baseurl=http://mirrors.kernel.org/mageia/distrib/$releasever/i586/media/debug/core/release/
+#metalink=https://mirrors.mageia.org/metalink?distrib=mageia-$releasever&arch=i586@&section=core&repo=release&debug=true
+mirrorlist=https://www.mageia.org/mirrorlist/?release=$releasever&arch=i586&section=core&repo=release&debug=1
+gpgcheck=1
+gpgkey=file:///etc/pki/mock/RPM-GPG-KEY-Mageia
+failovermethod=priority
+enabled=0
+
+[updates-debuginfo]
+name=Mageia $releasever - i586 - Updates - Debug
+#baseurl=http://mirrors.kernel.org/mageia/distrib/$releasever/i586/media/debug/core/updates/
+#metalink=https://mirrors.mageia.org/metalink?distrib=mageia-$releasever&arch=i586@&section=core&repo=updates&debug=true
+mirrorlist=https://www.mageia.org/mirrorlist/?release=$releasever&arch=i586&section=core&repo=updates&debug=1
+gpgcheck=1
+gpgkey=file:///etc/pki/mock/RPM-GPG-KEY-Mageia
+failovermethod=priority
+enabled=0
+
+"""
diff --git a/etc/mock/mageia-6-x86_64.cfg b/etc/mock/mageia-6-x86_64.cfg
new file mode 100644
index 0000000..3856dc8
--- /dev/null
+++ b/etc/mock/mageia-6-x86_64.cfg
@@ -0,0 +1,69 @@
+config_opts['root'] = 'mageia-6-x86_64'
+config_opts['target_arch'] = 'x86_64'
+config_opts['legal_host_arches'] = ('x86_64',)
+config_opts['chroot_setup_cmd'] = 'install basesystem-minimal rpm-build rpm-mageia-setup rpm-mageia-setup-build'
+config_opts['dist'] = 'mga6'  # only useful for --resultdir variable subst
+config_opts['extra_chroot_dirs'] = [ '/run/lock', ]
+config_opts['useradd'] = '/usr/sbin/useradd -o -m -u %(uid)s -g %(gid)s -d %(home)s %(user)s'
+config_opts['releasever'] = '6'
+config_opts['package_manager'] = 'dnf'
+
+config_opts['yum.conf'] = """
+[main]
+keepcache=1
+debuglevel=2
+reposdir=/dev/null
+logfile=/var/log/yum.log
+retries=20
+obsoletes=1
+gpgcheck=0
+assumeyes=1
+syslog_ident=mock
+syslog_device=
+install_weak_deps=0
+metadata_expire=0
+
+# repos
+
+[mageia]
+name=Mageia $releasever - x86_64
+#baseurl=http://mirrors.kernel.org/mageia/distrib/$releasever/x86_64/media/core/release/
+#metalink=https://mirrors.mageia.org/metalink?distrib=mageia-$releasever&arch=x86_64@&section=core&repo=release
+mirrorlist=https://www.mageia.org/mirrorlist/?release=$releasever&arch=x86_64&section=core&repo=release
+gpgcheck=1
+gpgkey=file:///etc/pki/mock/RPM-GPG-KEY-Mageia
+failovermethod=priority
+enabled=1
+
+[updates]
+name=Mageia $releasever - x86_64 - Updates
+#baseurl=http://mirrors.kernel.org/mageia/distrib/$releasever/x86_64/media/core/updates/
+#metalink=https://mirrors.mageia.org/metalink?distrib=mageia-$releasever&arch=x86_64@&section=core&repo=updates
+mirrorlist=https://www.mageia.org/mirrorlist/?release=$releasever&arch=x86_64&section=core&repo=updates
+gpgcheck=1
+gpgkey=file:///etc/pki/mock/RPM-GPG-KEY-Mageia
+failovermethod=priority
+enabled=1
+
+[mageia-debuginfo]
+name=Mageia $releasever - x86_64 - Debug
+#baseurl=http://mirrors.kernel.org/mageia/distrib/$releasever/x86_64/media/debug/core/release/
+#metalink=https://mirrors.mageia.org/metalink?distrib=mageia-$releasever&arch=x86_64@&section=core&repo=release&debug=true
+mirrorlist=https://www.mageia.org/mirrorlist/?release=$releasever&arch=x86_64&section=core&repo=release&debug=1
+gpgcheck=1
+gpgkey=file:///etc/pki/mock/RPM-GPG-KEY-Mageia
+failovermethod=priority
+enabled=0
+
+[updates-debuginfo]
+name=Mageia $releasever - x86_64 - Updates - Debug
+#baseurl=http://mirrors.kernel.org/mageia/distrib/$releasever/x86_64/media/debug/core/updates/
+#metalink=https://mirrors.mageia.org/metalink?distrib=mageia-$releasever&arch=x86_64@&section=core&repo=updates&debug=true
+mirrorlist=https://www.mageia.org/mirrorlist/?release=$releasever&arch=x86_64&section=core&repo=updates&debug=1
+gpgcheck=1
+gpgkey=file:///etc/pki/mock/RPM-GPG-KEY-Mageia
+failovermethod=priority
+enabled=0
+
+
+"""
-- 
2.5.5