diff --git a/cobbler/kickgen.py b/cobbler/kickgen.py
index 0b72690..2edb460 100644
--- a/cobbler/kickgen.py
+++ b/cobbler/kickgen.py
@@ -73,6 +73,11 @@ class KickGen:
         blended = utils.blender(self.api, False, obj)
         repos = blended["repos"] 
 
+        if is_profile:
+            distro = obj.get_conceptual_parent()
+        else:
+            distro = obj.get_conceptual_parent().get_conceptual_parent()
+
         # keep track of URLs and be sure to not include any duplicates
         included = {}
 
@@ -81,15 +86,52 @@ class KickGen:
             repo_obj = self.api.find_repo(repo)
             if repo_obj is not None:
                 if not repo_obj.yumopts.has_key('enabled') or repo_obj.yumopts['enabled'] == '1':
-                   if repo_obj.mirror_locally:
-                       baseurl = "http://%s/cobbler/repo_mirror/%s" % (blended["http_server"], repo_obj.name)
-                       if not included.has_key(baseurl):
-                           buf = buf + "repo --name=%s --baseurl=%s\n" % (repo_obj.name, baseurl)
-                       included[baseurl] = 1
-                   else:
-                       if not included.has_key(repo_obj.mirror):
-                           buf = buf + "repo --name=%s --baseurl=%s\n" % (repo_obj.name, repo_obj.mirror)
-                       included[repo_obj.mirror] = 1
+#                   original==start
+#                   if repo_obj.mirror_locally:
+#                       baseurl = "http://%s/cobbler/repo_mirror/%s" % (blended["http_server"], repo_obj.name)
+#                       if not included.has_key(baseurl):
+#                           buf = buf + "repo --name=%s --baseurl=%s\n" % (repo_obj.name, baseurl)
+#                       included[baseurl] = 1
+#                   else:
+#                       if not included.has_key(repo_obj.mirror):
+#                           buf = buf + "repo --name=%s --baseurl=%s\n" % (repo_obj.name, repo_obj.mirror)
+#                       included[repo_obj.mirror] = 1
+#                   original==end
+                    baseurl = ""
+                    if repo_obj.mirror_locally:
+                        baseurl = "http://%s/cobbler/repo_mirror/%s" % (blended["http_server"], repo_obj.name)
+                        included[baseurl] = 1
+                    else:
+                        baseurl = "%s" % (repo_obj.mirror)
+                        included[repo_obj.mirror] = 1
+                    
+                    #create buffer based on breed
+                    if distro.breed is None or distro.breed == "redhat":
+                        #template==start
+                        #repo --name=reponame --baseurl=url
+                        #template==end
+                        buf = buf + "repo --name=%s --baseurl=%s\n" % (repo_obj.name, baseurl)
+                    elif distro.breed == "suse":
+                        #template==start
+                        ##<listentry>
+                        ##     <media_url>http://myserver/SLES10/CD1/updates</media_url>
+                        ##     <product>SuSE-Linux-Updates</product>
+                        ##     <product_dir>/</product_dir>
+                        ##     <ask_on_error config:type="boolean">false</ask_on_error> <!-- available since openSUSE 11.0 -->
+                        ##     <name>MyUpdates</name> <!-- available since openSUSE 11.1/SLES11 (bnc#433981) -->
+                        ##</listentry>
+                        #template==end
+                        buf = buf + "<listentry>\n    <media_url>%s</media_url>\n    <product>%s</product>\n    <product_dir>/</product_dir>\n    <ask_on_error config:type='boolean'>false</ask_on_error> <!-- available since openSUSE 11.0 -->\n    <name>%s</name>\n</listentry>\n" % (baseurl, repo_obj.name, repo_obj.name)
+                    elif distro.breed == "debian" or distro.breed == "ubuntu":
+                        #template==start
+                        #d-i	mirror/country		string enter information manually
+                        #d-i	mirror/http/hostname	string http.us.debian.org
+                        #d-i	mirror/http/directory	string /debian
+                        #d-i	mirror/suite		string stable
+                        #d-i	mirror/http/proxy	string 
+                        #template==end
+                        #not enough knowledge to build stanza setting to default redhat
+                        buf = buf + "repo --name=%s --baseurl=%s\n" % (repo_obj.name, baseurl)
             else:
                 # FIXME: what to do if we can't find the repo object that is listed?
                 # this should be a warning at another point, probably not here
@@ -98,10 +140,10 @@ class KickGen:
                 # be useful.
                 pass
 
-        if is_profile:
-            distro = obj.get_conceptual_parent()
-        else:
-            distro = obj.get_conceptual_parent().get_conceptual_parent()
+#        if is_profile:
+#            distro = obj.get_conceptual_parent()
+#        else:
+#            distro = obj.get_conceptual_parent().get_conceptual_parent()
 
         source_repos = distro.source_repos
         count = 0
@@ -113,6 +155,7 @@ class KickGen:
 
         return buf
 
+
     def generate_config_stanza(self, obj, is_profile=True):
 
         """