diff -x '*.po' -d -urpN libreport.3/src/gui-wizard-gtk/wizard.c libreport.4/src/gui-wizard-gtk/wizard.c
--- libreport.3/src/gui-wizard-gtk/wizard.c	2012-04-04 11:44:38.000000000 +0200
+++ libreport.4/src/gui-wizard-gtk/wizard.c	2012-04-04 17:07:56.806859814 +0200
@@ -2027,6 +2027,7 @@ static void on_page_prepare(GtkAssistant
 
     if (pages[PAGENO_REPORT_PROGRESS].page_widget == page)
     {
+///FIXME: eliminate g_active_pb
         g_active_pb = g_pb_report;
         g_active_lbl = g_lbl_report_log;
     }
@@ -2116,16 +2117,18 @@ static gint select_next_page_no(gint cur
         break;
 #endif
 
-    case PAGENO_EDIT_BACKTRACE: /* == ANALYZE_SELECTOR+1 */
+///    case PAGENO_SUMMARY + 1:
+
+    case PAGENO_ANALYZE_SELECTOR + 1:
         if (!g_analyze_event_selected)
         {
             /* Go back to selectors */
             current_page_no = PAGENO_ANALYZE_SELECTOR-1;
             goto again;
         }
-        if (g_analyze_event_selected[0] == 'a')
+        event_config_t *cfg = get_event_config(g_analyze_event_selected);
+        if (cfg->ec_skip_review)
         {
-            /* It's an analyzer. Skip all review pages */
             current_page_no = PAGENO_REPORT_PROGRESS-1;
             goto again;
         }
diff -x '*.po' -d -urpN libreport.3/src/include/event_config.h libreport.4/src/include/event_config.h
--- libreport.3/src/include/event_config.h	2012-01-13 16:41:45.000000000 +0100
+++ libreport.4/src/include/event_config.h	2012-04-04 16:34:35.289772758 +0200
@@ -78,6 +78,7 @@ typedef struct
     char *ec_exclude_items_always;
     bool  ec_exclude_binary_items;
     long  ec_minimal_rating;
+    bool  ec_skip_review;
 
     GList *options;
 } event_config_t;
diff -x '*.po' -d -urpN libreport.3/src/lib/event_xml_parser.c libreport.4/src/lib/event_xml_parser.c
--- libreport.3/src/lib/event_xml_parser.c	2012-01-13 16:41:45.000000000 +0100
+++ libreport.4/src/lib/event_xml_parser.c	2012-04-04 16:33:53.742700528 +0200
@@ -31,6 +31,7 @@
 #define NAME_ELEMENT            "name"
 #define DEFAULT_VALUE_ELEMENT   "default-value"
 #define MINIMAL_RATING_ELEMENT  "minimal-rating"
+#define GUI_REVIEW_ELEMENTS     "gui-review-elements"
 
 #define REQUIRES_ELEMENT        "requires-items"
 #define EXCL_BY_DEFAULT_ELEMENT "exclude-items-by-default"
@@ -424,6 +425,12 @@ static void text(GMarkupParseContext *co
             }
             return;
         }
+        if (strcmp(inner_element, GUI_REVIEW_ELEMENTS) == 0)
+        {
+            ui->ec_skip_review = !string_to_bool(text_copy);
+            free(text_copy);
+            return;
+        }
     }
     free(text_copy);
 }
diff -x '*.po' -d -urpN libreport.3/src/plugins/report_Bugzilla.xml.in libreport.4/src/plugins/report_Bugzilla.xml.in
--- libreport.3/src/plugins/report_Bugzilla.xml.in	2012-01-13 16:41:45.000000000 +0100
+++ libreport.4/src/plugins/report_Bugzilla.xml.in	2012-04-04 16:29:28.352109743 +0200
@@ -9,6 +9,7 @@
     <exclude-binary-items>no</exclude-binary-items>
     <include-items-by-default></include-items-by-default>
     <minimal-rating>3</minimal-rating>
+    <gui-review-elements>yes</gui-review-elements>
 
     <options>
         <option type="text" name="Bugzilla_BugzillaURL">
diff -x '*.po' -d -urpN libreport.3/src/plugins/report_Kerneloops.xml.in libreport.4/src/plugins/report_Kerneloops.xml.in
--- libreport.3/src/plugins/report_Kerneloops.xml.in	2012-03-07 11:38:47.000000000 +0100
+++ libreport.4/src/plugins/report_Kerneloops.xml.in	2012-04-04 16:29:33.995978720 +0200
@@ -9,6 +9,7 @@
     <exclude-binary-items>yes</exclude-binary-items>
     <include-items-by-default></include-items-by-default>
     <minimal-rating>0</minimal-rating>
+    <gui-review-elements>yes</gui-review-elements>
 
     <options>
         <option type="text" name="KerneloopsReporter_SubmitURL">
diff -x '*.po' -d -urpN libreport.3/src/plugins/report_Logger.xml.in libreport.4/src/plugins/report_Logger.xml.in
--- libreport.3/src/plugins/report_Logger.xml.in	2012-01-13 16:41:45.000000000 +0100
+++ libreport.4/src/plugins/report_Logger.xml.in	2012-04-04 16:29:38.924706620 +0200
@@ -9,6 +9,7 @@
     <exclude-binary-items>yes</exclude-binary-items>
     <include-items-by-default></include-items-by-default>
     <minimal-rating>0</minimal-rating>
+    <gui-review-elements>yes</gui-review-elements>
 
     <options>
         <option type="text" name="Logger_Log_File">
diff -x '*.po' -d -urpN libreport.3/src/plugins/report_Mailx.xml.in libreport.4/src/plugins/report_Mailx.xml.in
--- libreport.3/src/plugins/report_Mailx.xml.in	2012-01-13 16:41:45.000000000 +0100
+++ libreport.4/src/plugins/report_Mailx.xml.in	2012-04-04 16:29:43.596371064 +0200
@@ -9,6 +9,7 @@
     <exclude-binary-items>no</exclude-binary-items>
     <include-items-by-default></include-items-by-default>
     <minimal-rating>0</minimal-rating>
+    <gui-review-elements>yes</gui-review-elements>
 
     <options>
         <option type="text" name="Mailx_Subject">
diff -x '*.po' -d -urpN libreport.3/src/plugins/report_RHTSupport.xml.in libreport.4/src/plugins/report_RHTSupport.xml.in
--- libreport.3/src/plugins/report_RHTSupport.xml.in	2012-01-13 16:41:45.000000000 +0100
+++ libreport.4/src/plugins/report_RHTSupport.xml.in	2012-04-04 16:29:47.660929790 +0200
@@ -9,6 +9,7 @@
     <exclude-binary-items>no</exclude-binary-items>
     <include-items-by-default></include-items-by-default>
     <minimal-rating>0</minimal-rating>
+    <gui-review-elements>yes</gui-review-elements>
 
     <options>
         <option type="text" name="RHTSupport_URL">
diff -x '*.po' -d -urpN libreport.3/src/plugins/report_Uploader.xml.in libreport.4/src/plugins/report_Uploader.xml.in
--- libreport.3/src/plugins/report_Uploader.xml.in	2012-01-13 16:41:45.000000000 +0100
+++ libreport.4/src/plugins/report_Uploader.xml.in	2012-04-04 16:29:51.646461910 +0200
@@ -9,6 +9,7 @@
     <exclude-binary-items>no</exclude-binary-items>
     <include-items-by-default></include-items-by-default>
     <minimal-rating>0</minimal-rating>
+    <gui-review-elements>yes</gui-review-elements>
 
     <options>
         <option type="text" name="Upload_URL">